#include <stdio.h>
#include <stdlib.h>
#include <string.h>
// Author: Arkadiusz Pawlik

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <climits>

using namespace std;

struct B {
  int a, b, h;
  B() {}
  B(int a_, int b_, int h_) : a(a_), b(b_), h(h_) {}
};
int coords;

vector<B> data;

void test() {
  data.clear();
  int n;
  cin >> n;
  map<int, int> coord_map;
  while(n--) {
    int a, b, h;
    cin >> a >> b >> h;
    data.push_back(B(a, b, h));
    coord_map[a] = -1;
    coord_map[b] = -1;
  }
  coords = 1;
  for (map<int, int>::iterator it = coord_map.begin();
                               it != coord_map.end(); ++it) {
    it->second = coords++;
  }
  map<int, int> imap;
  for (int i = 0; i < data.size(); ++i) {
    imap[coord_map[data[i].a]] = data[i].a;
    imap[coord_map[data[i].b]] = data[i].b;
    data[i].a = coord_map[data[i].a];
    data[i].b = coord_map[data[i].b];
  }
  vector<vector<int> > cost(coords+1, vector<int>(coords+1));
  for (int l = 1; l <= coords; ++l) {
    for (int x0 = 0; x0 + l <= coords; ++x0) {
      int h = 0, b = -1;
      for (int i = 0; i < data.size(); ++i) {
        if (x0 < data[i].a && data[i].b < x0 + l) {
	  if (data[i].h > h) {
          	h = data[i].h;
          	b = i;
	  }
        }
      }
      vector<int> check;
      int cost0 = 0;
      if (b != -1) {
        cost0 = INT_MAX;
	if (data[b].b-data[b].a <= 30) {
		for (int x1 = data[b].a; x1 <= data[b].b; ++x1) {
		  cost0 = min(cost0, h + cost[x0][x1-x0] + cost[x1][x0+l-x1]);
		}
	} else {
		vector<int> buffer(data[b].b+1-data[b].a, 0);
      		for (int i = 0; i < data.size(); ++i) {
        		if (x0 < data[i].a && data[i].b < x0 + l) {
				if (data[i].a >= data[b].a && data[i].a <= data[b].b) {
					buffer[data[i].a-data[b].a]++;
				}
				if (data[i].b >= data[b].a && data[i].b <= data[b].b) {
					buffer[data[i].b-data[b].a]--;
				}
        		}
      		}
		int best_i = 0, best_i2 = 0;
		// Find the highest density point.
		for (int i = 0, acc = 0, best_acc=-1; i<buffer.size(); ++i) {
			acc+=buffer[i];
			if (acc > best_acc) {
				best_acc += acc;
				best_i = i;
			}
			if (acc == best_acc) {
				best_i2 = i;
			}
		}
		check.push_back(data[b].a+best_i);
		check.push_back(data[b].a+best_i2);
		check.push_back(data[b].a);
		check.push_back(data[b].b);
		check.push_back((data[b].a+data[b].b)/2);
		// Arithmetic original coordinate mean.
		auto c1 = coord_map.lower_bound((imap[data[b].a] + imap[data[b].b])/2);
		if (c1 != coord_map.end()) check.push_back(c1->second);
		if (c1 != coord_map.begin()) check.push_back((--c1)->second);
		for (int x1 : check) {
		  cost0 = min(cost0, h + cost[x0][x1-x0] + cost[x1][x0+l-x1]);
		}
	}
      }
      cost[x0][l] = cost0;
    }
  }
  cout << cost[0][coords] << endl;
}
int main() {
  int Z;
  cin >> Z;
  while(Z--) test();
}

