#include <stdlib.h>
#include <string.h>

#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;
const int maxn = 300;
const int infty = 1000*1000*1000;
        int A[maxn],B[maxn],H[maxn];


typedef pair<int,int> PI;

int go(vector<PI> &events, int k, set<PI> &S)
{
    if (k>=events.size())
        return S.empty() ? 0 : infty;
    int where = events[k].first;
    int who = events[k].second;
    if (who<0)
    {
        who = -who;
        S.insert(PI(H[who],who));
//        printf("Starting %d (%d) at %d.\n",who,H[who],where);
    }
    else
    {
//        printf("Ending %d (%d) at %d.\n",who,H[who],where);
        if (S.find(PI(H[who],who))!=S.end())
            return infty;
    }
    int cost = go(events,k+1,S);
    set<PI> T = S;
    for(auto p : S)
    {
        T.erase(p);
//        printf("Trying %d at %d.\n",p.first,where);
        cost = min(cost,p.first + go(events,k+1,T));
    }
    return cost;
};

int main()
{
    int TT;
    scanf("%d",&TT);
    while(TT--)
    {
        int k;
        vector<PI> events;
        scanf("%d",&k);
        for(int i=1; i<=k; i++)
        {
            scanf("%d%d%d",&A[i],&B[i],&H[i]);
            events.push_back(PI(A[i],-i));
            events.push_back(PI(B[i],i));
        }
        sort(events.begin(),events.end());
        set<PI> S;
        printf("%d\n",go(events,0,S));
    }
}

