#include <stdlib.h>
#include <string.h>
// Author: Robert Obryk
#include <cstdio>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

struct scase {
    struct interval {
        int a, b, h;
        interval(){}
        interval(int _a, int _b, int _h) : a(_a), b(_b), h(_h) { }
    };
    vector<interval> ints;
    vector<int> points;
    map<pair<int, int>, int> memo;

    int solution(int from_i, int to_i) {
        pair<int,int> p(from_i, to_i);
        auto it = memo.find(p);
        if (it != memo.end())
            return it->second;
        // find highest interval
        interval highest(0,0,0);
        for(const auto& interval : ints) {
            if (interval.a > points[from_i] && interval.b < points[to_i] && interval.h > highest.h)
                highest = interval;
        }
        if (highest.h == 0)
            return 0;
        int a_i = lower_bound(points.begin(), points.end(), highest.a) - points.begin();
        int b_i = lower_bound(points.begin(), points.end(), highest.b) - points.begin();
        int minres = -1;
       for(int i=a_i;i<=b_i;i++) {
            int res = highest.h + solution(from_i, i) + solution(i, to_i);
            if (minres == -1 || res < minres)
                minres = res;
        }
        memo[p] = minres;
        return minres;
    }

    void dostuff() {
        int n;
        scanf("%d", &n);
        while (n--) {
            int a, b, h;
            scanf("%d%d%d", &a, &b, &h);
            ints.push_back(interval(a, b, h));
            points.push_back(a);
            points.push_back(b);
        }
        points.push_back(-1);
        points.push_back(20000);
        sort(points.begin(), points.end());
        points.resize(unique(points.begin(), points.end()) - points.begin());
        printf("%d\n", solution(0, points.size()-1));
    }
};

int main()
{
    int t;
    scanf("%d", &t);
    while(t--) {
        scase s;
        s.dostuff();
    }
    return 0;
}



