#include <stdlib.h>
// Author: Lech Duraj

#include <cstdio>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>

#define dprintf(...)
//#define dprintf(...) fprintf(stderr,__VA_ARGS__)

using namespace std;


typedef pair<int,int> PI;

const int maxn = 100*1000;
const int MAGIC = 500;

int pal[maxn];
char S[maxn];

int greedy(char* A, int n)
{
    if (n<=1)
        return n;
    int f = 0;
    int best = 0;
    pal[0] = 0;
    for(int i=1; i<n; i++)
    {
        if (f+pal[f]>i)
        {
            int j = f - (i - f);
            pal[i] = pal[j];
            int over = i+pal[i]-f-pal[f];
            if (over>0)
                pal[i] -= over;
        } 
        else
            pal[i] = 0;
        while(i+pal[i]<n && i-pal[i]>0 && A[i+pal[i]]==A[i-pal[i]-1])
        {
            pal[i]++;
            f = i;
        }
        if (pal[i]>pal[best])
            best = i;
    }
    return  1 + n - 2*pal[best] + greedy(A+best,pal[best]);
}


int dp(char *A, int n)
{
    vector< vector<int> > ispal(n);
    for(int i=0; i<n; i++)
        ispal[i].resize(n,false);
    vector< vector<int> > B(n);
    for(int i=0; i<n; i++)
        B[i].resize(n,n+1);
    for(int i=0; i+1<n; i++)
        ispal[i][i+1] = (A[i]==A[i+1]);
    for(int d=2; d<n; d++)
        for(int i=0; i+d<n; i++)
            if (A[i]==A[i+d] && ispal[i+1][i+d-1])
                ispal[i][i+d] = true;
    for(int i=0; i<n; i++)
    {
        B[i][i] = 1;
        if (i<n-1)
            B[i][i+1] = 2;
    }
    for(int d=2; d<n; d++)
        for(int i=0; i+d<n; i++)
        {
            B[i][i+d] = min(B[i][i+d-1],B[i+1][i+d])+1;
            if (d%2==1 && ispal[i][i+d])
                B[i][i+d] =  min(B[i][i+d],B[i][i+(d-1)/2]+1);
        }
    return B[0][n-1];
}


int main()
{
    int TT;
    scanf("%d\n",&TT);
    while(TT--)
    {
        fgets(S,maxn+2,stdin);
        int n = strlen(S);
        n--;
        S[n] = 0;
//        printf("%d\n",n);
        if (n<=MAGIC)
            printf("%d\n",dp(S,n));
        else
            printf("%d\n",greedy(S,n));
    }
}
