#include <stdio.h>
#include <stdlib.h>
#include <string.h>
// Author: Arkadiusz Pawlik
// Slow, O(n^4)

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void alg(const char *w, int n) {
  vector<int> res(n);
  vector<pair<int, int> > palindromes;
  for (int i = 0; i < n; ++i) {
    int r = 0;
    while (i-r-1 >= 0 && i+r < n && w[i-r-1] == w[i+r])
      ++r;
    res[i] = r;
    for (int j = 1; j <= r; ++j) {
      palindromes.push_back(make_pair(j, i));
    }
  }
  sort(palindromes.begin(), palindromes.end());
  vector<int> savings(palindromes.size());
  for (int i = 0; i < palindromes.size(); ++i) {
    int r1 = palindromes[i].first;
    int center1 = palindromes[i].second;
    int max_savings = r1 - 1;
    for (int j = 0; j < i; ++j) {
      int r2 = palindromes[j].first;
      int center2 = palindromes[j].second;
      if (center1-r1 <= center2-r2 && center2+r2 <= center1+r1) {
        max_savings = max(max_savings, savings[j]);
      }
      if (center1-r1 <= center2-r2 && center2+r2 <= center1) {
        max_savings = max(max_savings, savings[j]+r1-1);
      }
    }
    savings[i] = max_savings;
  }
  savings.push_back(0);
  cout << n - *max_element(savings.begin(), savings.end()) << endl;
}

int main() {
  int n;
  cin >> n;
  while (n--) {
    string s;
    cin >> s;
    alg(s.c_str(), s.size());
  }
}
