#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

vector<string> result;

void gen_small(int len, int x, int alpha, int reflect, int len_more, int y, int split = 0) {
  string s;
  for (int i = 0; i < len; ++i) {
    s.push_back("ATGC"[x%alpha]);
    x /= alpha;
  }
  if (reflect) {
    string z = s;
    reverse(z.begin(), z.end());
    for (int i = 0; i < z.size(); ++i) s.push_back(z[i]);
    int len_more2 = split%(len_more+1);
    for (int i = 0; i < len_more-len_more2; ++i) {
      s.push_back("ATGC"[y%alpha]);
      y /= alpha;
    }
    reverse(s.begin(), s.end());
    for (int i = 0; i < len_more2; ++i) {
      s.push_back("ATGC"[y%alpha]);
      y /= alpha;
    }
  }
  result.push_back(s);
}

int power(int len, int alpha) {
  int res = 1;
  while(len--) {
    res *= alpha;
  }
  return res;
}

void gen_all_small(int len, int alpha, int reflect, int len_more = 0) {
  int x_max = power(len, alpha);
  int y_max = !reflect ? 1 : power(len_more, alpha);
  for (int x = 0; x < x_max; ++x) {
    for (int y = 0; y < y_max; ++y) {
      for (int split = 0; split == 0 || split < len_more; ++split) {
        gen_small(len, x, alpha, reflect, len_more, y, split);
      }
    }
  }
}

void gen_all_small_2() {
  gen_all_small(1, 4, 0);
  gen_all_small(2, 4, 0);
  gen_all_small(3, 4, 0);
  gen_all_small(4, 4, 0);
  gen_all_small(5, 4, 0);
  gen_all_small(6, 4, 0);
  gen_all_small(7, 4, 0);
  gen_all_small(8, 3, 0);
  gen_all_small(9, 3, 0);
  gen_all_small(10, 3, 0);
  gen_all_small(11, 2, 0);
  gen_all_small(12, 2, 0);
  gen_all_small(13, 2, 0);
  gen_all_small(14, 2, 0);
  gen_all_small(6, 3, 1, 2);
  gen_all_small(7, 3, 1, 1);
  gen_all_small(8, 3, 1, 1);
  gen_all_small(8, 2, 1, 5);
}

void gen(int div, int max_val, int max_size = 100000, int max_reflect = 100, int reflects = 10) {
  string res;
  string s;
  for (int i = 0; i < max_size/div; ++i) {
    s.push_back("ATGC"[rand()%max_val]);
  }
  for (int i = 0; i < div; ++i) {
    for (int z = 0; z < s.size(); ++z) res.push_back(s[z]);
    reverse(s.begin(), s.end());
  }
  while (res.size() < max_size) {
    res.push_back("ATGC"[rand()%max_val]);
  }
  vector<pair<int, int> > r_set;
  for (int i = 0; i < reflects; ++i) {
    int ms = max_reflect/2;
    if (ms <= 0) ms = 1;
    int size = 1 + rand()%ms;
    int pos = rand()%(max_size - 2*size + 1);
    r_set.push_back(make_pair(pos, size));
  }
  sort(r_set.begin(), r_set.end());
  for (int i = 0; i < r_set.size(); ++i) {
    int pos = r_set[i].first, size = r_set[i].second;
    for (int j = 0; j < size; ++j) {
      res[pos+size+j] = res[pos+size-1-j];
    }
  }
  result.push_back(res);
}

void make_fib() {
  string s = "A";
  while (true) {
    string z;
    for (int i = 0; i < s.size(); ++i) {
      if (s[i] == 'A') {
        z.push_back('A');
        z.push_back('G');
      } else {
        z.push_back('A');
      }
      if (z.size() > 100000) {
        result.push_back(s);
        return;
      }
    }
    s = z;
  }
}

int main() {
  gen_all_small_2();
  gen(7, 4);
  gen(7, 3);
  gen(7, 2);
  gen(8, 4);
  gen(8, 3);
  gen(8, 2);
  gen(9, 4);
  gen(9, 3, 100000, 20, 1000000);
  gen(9, 3, 100000, 100, 50000);
  gen(9, 3, 100000, 1000, 41000);
  gen(9, 2);
  gen(15, 2, 100000, 1000, 10);
  for (int i = 10; i < 40; ++i) {
    gen(i, 3);
  }
  for (int i = 3; i < 15; ++i) {
    gen(i, 3, 100000, 0, 0);
  }
  gen(10, 1, 100000, 0, 0);
  make_fib();
  cout << result.size() << endl;
  for (int i = 0; i < result.size(); ++i) cout << result[i] << endl;
}
