// Author: Adam Polak
// O(n^3)

#include <cstring>
#include <iostream>
using namespace std;

const int MAXL = 1e6;
const int MOD = 1e9 + 9;

char s1[MAXL + 1], s2[MAXL + 1], s3[MAXL + 1];
int n1, n2, n3;

int WaysEqual(char a, char b) {
  if (a == '?' && b == '?')
    return 26;
  if (a == '?' || b == '?')
    return 1;
  return a == b ? 1 : 0;
}

int WaysEqual(char a, char b, char c) {
  if (a == '?' && b == '?' && c == '?')
    return 26;
  if (a != '?' && b != '?' && a != b)
    return 0;
  if (b != '?' && c != '?' && b != c)
    return 0;
  if (c != '?' && a != '?' && c != a)
    return 0;
  return 1;
}

int WaysLess(char a, char b) {
  // cerr << "Ways< " << a << " " << b << endl;
  if (a == '?' && b == '?')
    return 25 * 26 / 2;
  if (a != '?' && b != '?')
    return a < b ? 1 : 0;
  if (a == '?')
    return b >= 'a' ? b - 'a' : 0;
  if (b == '?')
    return 'z' - a;
}

int WaysLessEqual(char a, char b, char c) {
  if (b != c && b != '?' && c != '?')
    return 0;
  if (b == '?')
    return WaysLess(a, c);
  else
    return WaysLess(a, b);
}

int WaysEqualLess(char a, char b, char c) {
  if (a != b && a != '?' && b != '?')
    return 0;
  if (b == '?')
    return WaysLess(a, c);
  else
    return WaysLess(b, c);
}

int WaysLessLess(char a, char b, char c) {
  // cerr << "Ways<< " << a << " " << b << " " << c << endl;
  int a_start = a == '?' ? 'a' : a;
  int a_end   = a == '?' ? 'z' : a;
  int b_start = b == '?' ? 'a' : b;
  int b_end   = b == '?' ? 'z' : b;
  int c_start = c == '?' ? 'a' : c;
  int c_end   = c == '?' ? 'z' : c;
  // cerr << a_start << " " << a_end << " " << b_start << " " << b_end << " " << c_start << " " << c_end << endl;
  int count = 0;
  for (int x = b_start; x <= b_end; ++x)
    count +=
      max(0, min(a_end, x - 1) - a_start + 1) *
      max(0, c_end - max(c_start, x + 1) + 1);
  // cerr << count << endl;
  return count;
}

int main() {
  ios_base::sync_with_stdio(false);
  int Z;
  cin >> Z;
  while (Z--) {
    cin >> s1 >> s2 >> s3;
    n1 = strlen(s1);
    n2 = strlen(s2);
    n3 = strlen(s3);
    s1[n1] = s2[n2] = s3[n3] = 'a' - 1;
    long long total = 0;
    for (int a = 0; a <= min(n1, n2); ++a) {
      for (int b = 0; b <= min(n2, n3); ++b) {
        long long count = 1;
        for (int i = 0; i < min(a, b); ++i)
          count = (count * WaysEqual(s1[i], s2[i], s3[i])) % MOD;
        
        for (int i = a + 1; i < n1; ++i)
          count = (count * (s1[i] == '?' ? 26 : 1)) % MOD;
        for (int i = max(a, b) + 1; i < n2; ++i)
          count = (count * (s2[i] == '?' ? 26 : 1)) % MOD;
        for (int i = b + 1; i < n3; ++i)
          count = (count * (s3[i] == '?' ? 26 : 1)) % MOD;
        
        for (int i = a + 1; i < b; ++i)
          count = (count * WaysEqual(s2[i], s3[i])) % MOD;
        for (int i = b + 1; i < a; ++i)
          count = (count * WaysEqual(s1[i], s2[i])) % MOD;

        if (a < b) {
          count = (count * WaysLess(s2[b], s3[b])) % MOD;
          // cerr << "a < b, " << count << endl;
          count = (count * WaysLessEqual(s1[a], s2[a], s3[a])) % MOD;
        } else if (a == b) {
          count = (count * WaysLessLess(s1[a], s2[a], s3[a])) % MOD;
        } else {  // a > b
          count = (count * WaysLess(s1[a], s2[a])) % MOD;
          // cerr << "a > b, " << count << endl;
          count = (count * WaysEqualLess(s1[b], s2[b], s3[b])) % MOD;
        }
        total = (total + count) % MOD;
        // if (count > 0) cerr << "a = " << a << " b = " << b << " count = " << count << endl;
      }
    }
    cout << total << endl;
  }
}
