#include <stdio.h>
#include <string.h>
// Author: Adam Polak
#include <algorithm>
#include <cstdlib>
#include <iostream>
#include <string>
using namespace std;

string RandString(int min_n, int max_n) {
  string s(min_n + lrand48() % (max_n - min_n + 1), '?');
  for (int i = 0; i < s.length(); ++i)
    s[i] = 'a' + lrand48() % ('z' - 'a');
  return s;
}

string RandQ(int p, const string& s) {
  string t = s;
  for (int i = 0; i < s.length(); ++i)
    if (lrand48() % 100 < p)
      t[i] = '?';
  return t;
}

void OnlyQ(int n) {
  for (int i = 0; i < 3; ++i)
    cout << string(n, '?') << endl;
}

void Aaa(int n, int m, int k) {
  cout << string(n, 'a') << endl;
  cout << string(m, 'a') << endl;
  cout << string(k, 'a') << endl;
}

void AllEqual(int min_n, int max_n, int p) {
  string s = RandString(min_n, max_n);
  for (int i = 0; i < 3; ++i)
    cout << RandQ(p, s) << endl;
}

void FullRand(int min_n, int max_n, int p) {
  string s[3];
  for (int i = 0; i < 3; ++i)
    s[i] = RandString(min_n, max_n);
  sort(s, s + 3);
  for (int i = 0; i < 3; ++i)
    cout << RandQ(p, s[i]) << endl;
}

void OneDiff(int min_n, int max_n, int p) {
  string common = RandString(min_n / 2, max_n / 2);
  string s[3];
  for (int i = 0; i < 3; ++i)
    s[i] = common + RandString(min_n / 2, max_n / 2);
  sort(s, s + 3);
  for (int i = 0; i < 3; ++i)
    cout << RandQ(p, s[i]) << endl;
}

void TwoDiff(int min_n, int max_n, int p, bool type) {
  string common = RandString(min_n / 3, max_n / 3);
  string common12 = RandString(min_n / 3, max_n / 3);
  string common23 = RandString(min_n / 3, max_n / 3);
  cout << RandQ(p, common + "j" + common12 + "j" + RandString(min_n / 3, max_n / 3)) << endl;
  if (type)
    cout << RandQ(p, common + "j" + common12 + "u" + RandString(min_n / 3, max_n / 3)) << endl;
  else
    cout << RandQ(p, common + "u" + common23 + "u" + RandString(min_n / 3, max_n / 3)) << endl;
  cout << RandQ(p, common + "u" + common23 + "u" + RandString(min_n / 3, max_n / 3)) << endl;

}

int main() {
  srand48(0xce9c14);

  cout << 13 << endl;

  OnlyQ(1e6);

  Aaa(9999, 10000, 10001);

  AllEqual(1e5, 2e5, 10);
  AllEqual(1e5, 2e5, 50);
  AllEqual(1e5, 2e5, 90);

  FullRand(1e5, 2e5, 95);
  FullRand(2e5, 4e5, 95);
  FullRand(1e5, 2e5, 99);
  FullRand(2e5, 4e5, 99);

  OneDiff(5e5, 10e5, 5);
  OneDiff(5e5, 10e5, 25);
  TwoDiff(5e5, 10e5, 10, true);
  TwoDiff(5e5, 10e5, 15, false);
}
