// Author: Adam Polak
// Backtrack with memoization
#include <deque>
#include <iostream>
#include <set>
#include <string>
#include <utility>
using namespace std;

int n;
int A[1000];
char solution[1000 + 1];

set< pair<deque<int>, int> > wrong;

void push_back(deque<int>& blocks, int a) {
  while (!blocks.empty() && blocks.back() == a) {
    a *= 2;
    blocks.pop_back();
  }
  blocks.push_back(a);
}

void push_front(deque<int>& blocks, int a) {
  while (!blocks.empty() && blocks.front() == a) {
    a *= 2;
    blocks.pop_front();
  }
  blocks.push_front(a);
}

bool rec(deque<int> blocks, int i) {
  if (wrong.count(make_pair(blocks, i))) return false;
  wrong.insert(make_pair(blocks, i));
  if (i == n) {
    if (blocks.size() == 1) {
      solution[i] = 0;
      cout << solution << endl;
      return true;
    } else {
      return false;
    }
  }
  int a = A[i];
  if (blocks.size() < 2 || (blocks.back() >= a && blocks.front() < a)) {
    push_back(blocks, a);
    solution[i] = 'r';
    return rec(blocks, i + 1);
  }
  if (blocks.back() < a && blocks.front() >= a) {
    push_front(blocks, a);
    solution[i] = 'l';
    return rec(blocks, i + 1);
  }
  if (blocks.back() < a && blocks.front() < a) {
    bool only_asc = true, only_desc = true;
    for (int j = 0; j < blocks.size() - 1; ++j) {
      if (blocks[j] < blocks[j+1])
        only_desc = false;
      else
        only_asc = false;
    }
    if (only_asc) {
      push_back(blocks, a);
      solution[i] = 'r';
      return rec(blocks, i + 1);
    } else if (only_desc) {
      push_front(blocks, a);
      solution[i] = 'l';
      return rec(blocks, i + 1);
    } else {
      return false;
    }
  }
  deque<int> alt_blocks = blocks;
  push_back(blocks, a);
  solution[i] = 'r';
  if (rec(blocks, i + 1))
    return true;
  push_front(alt_blocks, a);
  solution[i] = 'l';
  return rec(alt_blocks, i + 1);
}

int main() {
  ios_base::sync_with_stdio(false);

  int Z;
  cin >> Z;
  while (Z--) {
    cin >> n;
    for (int i = 0; i < n; ++i)
      cin >> A[i];
    deque<int> empty_blocks;
    if (!rec(empty_blocks, 0))
      cout << "no\n";
    wrong.clear();
  }
}
