#include <stdlib.h>
#include <string.h>
// Author: Lech Duraj
// O(mn + q log n), O(mn) memory -- should not fit inside the limit!

#include <cstdio>
#include <algorithm>
#include <vector>
#include <functional>

using namespace std;

//#define dprintf(...) fprintf(stderr,__VA_ARGS__)
#define dprintf(...)

const int infty = 1e9+1;

typedef pair<int,int> PII;

struct edge_type
{
    int a, b, w;
};

bool operator<(edge_type e, edge_type f)
{
    return e.w < f.w;
}

vector<edge_type> edge;
vector< vector<PII> > spanning;

vector< vector<int> > trees;
vector< vector<int> > prefix;
int M;


int heaviest(int x, int p, int goal)
{
    int j = -infty;
    if (x==goal)
        return -1;
    for(PII u : spanning[x])
    {
        int y = u.first;
        int e = u.second;
        if (y==p)
            continue;
        int w = edge[e].w;
        int res = heaviest(y, x, goal);
        if (res!=-infty)
        {
            if (res==-1 || w>edge[res].w)
                j = e;
            else
                j = res;
        }
    }
    return j;
}

int main()
{
    int TT;
    scanf("%d",&TT);
    while(TT--)
    {
        int n, m;
        scanf("%d%d",&n,&m);
        edge.resize(m);
        for(int i=0; i<m; i++)
        {
            scanf("%d%d%d",&edge[i].a,&edge[i].b,&edge[i].w);
            edge[i].a--;
            edge[i].b--;
        }
        sort(edge.begin(),edge.end());
        spanning.clear();
        spanning.resize(m);
        trees.clear();
        prefix.clear();
        trees.resize(m);
        prefix.resize(m);
        for(int i=m-1; i>=0; i--)
        {
            trees[i].clear();
            if (i<m-1)
                trees[i] = trees[i+1];
            prefix[i].clear();
            dprintf("%d: Edge %d - %d (%d).\n",i,edge[i].a,edge[i].b,edge[i].w);
            int a = edge[i].a;
            int b = edge[i].b;
            int j = heaviest(a,-1,b);
            if (j!=-infty)
            {
                dprintf("Displacing %d (%d - %d).\n",j,edge[j].a,edge[j].b);
                int x = edge[j].a;
                int y = edge[j].b;
                for(auto t=spanning[x].begin(); t!=spanning[x].end(); t++)
                    if (t->first ==y)
                    {
                        spanning[x].erase(t); break;
                    }
                for(auto t=spanning[y].begin(); t!=spanning[y].end(); t++)
                    if (t->first ==x)
                    {
                        spanning[y].erase(t); break;
                    }
                for(auto t = trees[i].begin(); t!=trees[i].end(); t++)
                    if (*t==edge[j].w)
                    {
                        trees[i].erase(t); break;
                    }
            }
            reverse(trees[i].begin(), trees[i].end());
            trees[i].push_back(edge[i].w);
            reverse(trees[i].begin(), trees[i].end());
            spanning[a].push_back(PII(b,i));
            spanning[b].push_back(PII(a,i));
            prefix[i].push_back(0);
            for(auto a : trees[i])
                prefix[i].push_back(prefix[i].back()+a);
/*            dprintf("%d:\n",i);
            for(auto a : trees[i])
                dprintf("%d ",a);
            dprintf("\n");
            for(auto a : prefix[i])
                dprintf("%d ",a);
            dprintf("\n"); */
        }
        int ans = 0;
        int q;
        scanf("%d",&q);
        for(int j=0; j<q; j++)
        {
            edge_type e;
            int x, y;
            scanf("%d %d",&x,&y);
            x -= ans;
            y -= ans;
            e.w = x;
            int p = lower_bound(edge.begin(),edge.end(),e)-edge.begin();
            int q = upper_bound(trees[p].begin(),trees[p].end(),y)-trees[p].begin();
            dprintf("Query %d: edges of %d, first %d.\n",j,p,q);
            ans = prefix[p][q];
            printf("%d\n",ans);
        }
    }
}
