#include <stdio.h>
#include <stdlib.h>
#include <string.h>
// author: Grzegorz Herman

#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
using namespace std;

struct vertex
{
    vertex * link;

    vertex() : link(this)
    {
    }

    vertex(vertex const &) = delete;

    vertex * find()
    {
        return (link == this) ? this : (link = link->find());
    }

    void unio(vertex * that)
    {
        this->find()->link = that->find();
    }
};

void testcase()
{
    int n, m;
    cin >> n >> m;
    vector<pair<int,pair<int,int>>> E(m);
    for (int i=0; i<m; ++i)
        cin >> E[i].second.first >> E[i].second.second >> E[i].first;
    sort(E.begin(), E.end());
    int q;
    int weight = 0;
    for (cin >> q; q; --q)
    {
        int l, h;
        cin >> l >> h;
        l -= weight; h -= weight;
        vertex V[n+1];
        int parts = n;
        weight = 0;
        for (int i=0; i<m; ++i)
        {
            if (E[i].first < l)
                continue;
            if (E[i].first > h)
                break;
            vertex * u = V+E[i].second.first;
            vertex * v = V+E[i].second.second;
            if (u->find() == v->find())
                continue;
            u->unio(v);
            parts--;
            weight += E[i].first;
        }
        cout << /* parts << " " << */ weight << endl;
    }
}

int main()
{
    int z;
    for (cin >> z; z; --z)
        testcase();
    return 0;
}
