#include <stdlib.h>
// Author: Damian Straszak

#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <queue>
#include <map>
#include <cstdio>
#include <iomanip>
#include <sstream>
#include <iostream>
#include <cstring>
#include <complex>
#define REP(i,x,v)for(int i=x;i<=v;i++)
#define REPD(i,x,v)for(int i=x;i>=v;i--)
#define FOR(i,v)for(int i=0;i<v;i++)
#define FORE(i,t) for (typeof(t.begin()) i=t.begin(); i!=t.end(); i++)
#define REMIN(x,y) (x)=min((x),(y))
#define REMAX(x,y) (x)=max((x),(y))
#define pb push_back
#define sz size()
#define mp make_pair
#define fi first
#define se second
#define ll long long
#define IN(x,y) ((y).find((x))!=(y).end())
#define un(v) v.erase(unique(ALL(v)),v.end())
#define ALL(x) (x).begin(),(x).end()
#define DBG(vari) cerr<<#vari<<" = "<<vari<<endl;
using namespace std;
typedef pair<int,int> pii;
typedef vector<int> vi;
template<typename T,typename TT> ostream &operator<<(ostream &s,pair<T,TT> t) {return s<<"("<<t.first<<","<<t.second<<")";}
template<typename T> ostream &operator<<(ostream &s,vector<T> t){s<<"{";FOR(i,t.size())s<<t[i]<<(i==t.size()-1?"":",");return s<<"}"<<endl; }

#define N 100000
#define K 1000000000


ll ran()
{
	ll x=0;
	FOR(i,6) x=x*(1<<10)+rand()%(1<<10);
	return x;
}

ll ran2(int d)
{
	return 1+ran()%(1LL<<(1+ran()%d));
}

ll ran_exp(int d,int mult=2)
{
	int g=1;
	while(rand()%2 && g<d) g*=mult;
	g=min(g,d);
	return 1+ran()%g;
}

vector<pair<int,char> > partition(ll x,char c)
{
	vector<pair<int,char> > w;
	while(1)
	{
		int r=1+ran()%20;
		int z=1+ran()%(1<<r);
		
		if (x<=z)
		{
			w.pb(mp(x,c));
			break;
		}
		w.pb(mp(z,c));
		x-=z;
	}
	return w;
}

void print_compressed(vector<char> v)
{
	vector<pair<int,char> > w;
	int i=0;
	int n=v.sz;
	while(i<n)
	{
		int i1=i;
		while(i1<n && v[i1]==v[i]) i1++;
		w.pb(mp(i1-i,v[i]));
		i=i1;
	}
	cout<<w.sz<<"\n";
	FOR(i,w.sz) cout<<w[i].fi<<" "<<w[i].se<<"\n";
}

void print_normal(vector<char> v)
{
	cout<<v.sz<<"\n";
	FOR(i,v.sz) cout<<1<<" "<<v[i]<<"\n";
}


void gen_full(int cases)
{
	while(cases--)
	{
		char C=(cases%2?'W':'B');
		int n=N;
		int k=K/n;
		cout<<n<<"\n";
		FOR(i,n) cout<<k<<" "<<C<<"\n";
	}
}

void gen_full_rand(int cases)
{
	while(cases--)
	{
		char C=(cases%2?'W':'B');
		int n=1+ran()%N;
		int k=K/n;
		cout<<n<<"\n";
		FOR(i,n) cout<<1+ran()%k<<" "<<C<<"\n";
	}
}

void gen_rand_small_ratio(int cases,int maxn,bool compr=0)
{
	while(cases--)
	{
		int x=1+ran()%5;
		int y=1+ran()%5;
		vector<char> v,w;
		ll sum=0;
		while(1)
		{
			w.clear();
			int z=1+ran()%10;
			FOR(i,z*x) w.pb('W');
			FOR(i,z*y) w.pb('B');
			sum+=z*1LL*(x+y);
			random_shuffle(ALL(w));
			if (sum>K) break;
			if (v.sz+w.sz>maxn) break;
			FOR(i,w.sz) v.pb(w[i]);
		}
		if (compr) print_compressed(v);
		else print_normal(v);
		
	}
}

void gen_rand_compressed(int cases,int maxn,int logratio)
{
	while(cases--)
	{
		ll x=ran2(logratio);
		ll y=ran2(logratio);
		vector<pair<int,char> > v;
		ll mx=10000/max(x,y)+1;
		ll sum=0;
		while(1)
		{
			vector<pair<int,char> > w,w1,w2;
			ll z=1+ran()%mx;
			w1=partition(z*x,'W');
			w2=partition(z*y,'B');
			sum+=z*1LL*(x+y);
			w.insert(w.end(),ALL(w1));
			w.insert(w.end(),ALL(w2));
			random_shuffle(ALL(w));
			if (sum>K) break;
			if (v.sz+w.sz>maxn) break;
			else v.insert(v.end(),ALL(w));
		}
		if (v.sz==0)
		{
			cases++;
			continue;
		}
		//DBG(mp(v.sz,sum));
		cout<<v.sz<<"\n";
		FOR(i,v.sz) cout<<v[i].fi<<" "<<v[i].se<<"\n";
		
	}
}

void gen_garbage(int cases,int n)
{
	while(cases--)
	{
		cout<<n<<"\n";
		FOR(i,n) cout<<1+ran()%(K/n)<<" "<<(ran()%2?'W':'B')<<"\n";
	}
}

void gen_small(int cases,bool compr=0)
{
	FOR(x,cases)
	{
		vector<char> v;
		int X=x;
		while(1)
		{
			v.pb(X%2?'W':'B');
			X/=2;
			if (X==0) break;
		}
		if (compr) print_compressed(v);
		else print_normal(v);
	}
}

void gen_small_inflate(int cases)
{
	FOR(x,cases)
	{
		vector<char> v;
		int X=x;
		while(1)
		{
			v.pb(X%2?'W':'B');
			X/=2;
			if (X==0) break;
		}
		int l=K/v.sz;
		cout<<v.sz<<"\n";
		FOR(i,v.sz) cout<<l<<" "<<v[i]<<"\n";
	}
}

void gen_handcrafted1(int cases,ll x,ll y,int distr_mult=2)
{
	vector<pair<int,char> > v;
	ll sum=0;
	while(v.sz<N-3000)
	{
		ll z=ran_exp(1e6,distr_mult);
		ll zx=z*x,zy=z*y;
		sum+=zx+zy;
		if (sum>K) break;
		string s="WB";
		if (ran()%2) swap(s[0],s[1]);
		while(zx)
		{
			ll g=ran2(18);
			if (zx<=g){v.pb(mp(zx,s[0]));zx=0;}
			else{v.pb(mp(g,s[0]));zx-=g;}
		}
		while(zy)
		{
			ll g=ran2(18);
			if (zy<=g){v.pb(mp(zy,s[1]));zy=0;}
			else{v.pb(mp(g,s[1]));zy-=g;}
		}
	}
	cout<<v.sz<<"\n";
	FOR(i,v.sz) cout<<v[i].fi<<" "<<v[i].se<<"\n";
}



int main()
{
	ios_base::sync_with_stdio(0);
	srand(11);
	vi v;
	int x;
	int total_tests=0;
	while(cin>>x)
	{
		v.pb(x);
		total_tests+=x;
	}
	int nr=0;
	cout<<total_tests<<"\n";
	gen_small(v[nr++],0);
	gen_small(v[nr++],1);
	gen_small_inflate(v[nr++]);
	gen_full(v[nr++]);
	gen_full_rand(v[nr++]);
	gen_garbage(v[nr++],50000);
	gen_rand_small_ratio(v[nr++],500,0);
	gen_rand_small_ratio(v[nr++],500,1);
	gen_rand_small_ratio(v[nr++],10000,0);
	gen_rand_small_ratio(v[nr++],10000,1);
	gen_rand_small_ratio(v[nr++],50000,0);
	gen_rand_small_ratio(v[nr++],50000,1);
	gen_rand_small_ratio(v[nr++],100000,0);
	gen_rand_small_ratio(v[nr++],100000,1);
	gen_rand_compressed(v[nr++],10000,5);
	gen_rand_compressed(v[nr++],10000,10);
	gen_rand_compressed(v[nr++],10000,21);
	gen_rand_compressed(v[nr++],50000,3);
	gen_rand_compressed(v[nr++],100000,14);
	gen_handcrafted1(v[nr++],1,2,4);
	gen_handcrafted1(v[nr++],7,2,4);
	gen_handcrafted1(v[nr++],3,2,2);
	gen_handcrafted1(v[nr++],201,20,3);
	return 0;
}













