#include <iostream>
#include <vector>
using namespace std;

struct point
{
    int x, y;
    
    friend point operator-(point p, point q)
    {
        point r;
        r.x = p.x - q.x;
        r.y = p.y - q.y;
        return r;
    }

    friend long long operator*(point p, point q)
    {
        return 1LL*p.x*q.y - 1LL*p.y*q.x;
    }
};

void testcase()
{
    int n;
    cin >> n;
    vector<point> P(n);
    for (auto & p : P)
        cin >> p.x >> p.y;
    for (int i=0; i<n-2; ++i)
    {
        int j = i+2;
        while (j<n && ((P[j]-P[i]) * (P[i+1]-P[i]) >= 0))
            ++j;
        cout << (j<n ? j : 0) << ' ';
    }
    cout << 0 << endl;
}

int main()
{
    int z;
    for (cin >> z; z; --z)
        testcase();
    return 0;
}
