#include <iostream>
#include <queue>
#include <tuple>
#include <vector>
using namespace std;

struct point
{
    int x, y;
};

double intersect(point p, point q, point r, point s)
{
    if (1LL*(q.y-p.y)*(s.x-r.x) >= 1LL*(s.y-r.y)*(q.x-p.x))
        return -1.0;
    double pqa = 1.0*(q.y-p.y)/(q.x-p.x);
    double rsa = 1.0*(s.y-r.y)/(s.x-r.x);
    double pqb = p.y - pqa*p.x;
    double rsb = r.y - rsa*r.x;
    return (pqb-rsb)/(rsa-pqa);
}

void ps(vector<int> const & v)
{
    //cerr << "[";
    for (auto x : v)
    {
        //cerr << x << ' ';
    }
    //cerr << "]" << endl;
}

void testcase()
{
    int n;
    cin >> n;
    vector<point> P(n);
    for (auto & p : P)
        cin >> p.x >> p.y;
    vector<int> R(n-2, 0);
    vector<int> L;
    typedef tuple<double,int,int,int> event;
    priority_queue<event, vector<event>, greater<event>> E;
    for (int i=0; i<n-1; ++i)
    {
        //cerr << "i = " << i << ", x = " << P[i+1].x << endl;
        while (!E.empty())
        {
            event e = E.top();
            //cerr << "top is " << get<0>(e) << ' ' << get<1>(e) << ' ' << get<2>(e) << ' ' << get<3>(e) << endl;
            if (get<0>(e) > P[i+1].x)
                break;
            //cerr << get<0>(e) << ' ' << get<1>(e) << ' ' << get<2>(e) << ' ' << get<3>(e) << endl;
            E.pop();
            int j = get<1>(e);
            if (j+1 >= L.size() || L[j] != get<2>(e) || L[j+1] != get<3>(e))
                continue;
            //cerr << "swap " << L[j] << " and " << L[j+1] << endl;
            swap(L[j], L[j+1]);
            ps(L);
            if (j > 0)
            {
                double x = intersect(P[L[j-1]], P[L[j-1]+1], P[L[j]], P[L[j]+1]);
                //cerr << "new neighbours " << L[j-1] << " and " << L[j] << ", x = " << x << endl;
                if (x > 0)
                    E.emplace(x, j-1, L[j-1], L[j]);
            }
            if (j+2 < L.size())
            {
                double x = intersect(P[L[j+1]], P[L[j+1]+1], P[L[j+2]], P[L[j+2]+1]);
                //cerr << "new neighbours " << L[j+1] << " and " << L[j+2] << ", x = " << x << endl;
                if (x > 0)
                    E.emplace(x, j+1, L[j+1], L[j+2]);
            }
        }
        while (!L.empty())
        {
            int j = L.back();
            if (1LL*(P[i+1].x-P[j].x)*(P[j+1].y-P[j].y) >= 1LL*(P[i+1].y-P[j].y)*(P[j+1].x-P[j].x))
                break;
            //cerr << "pop " << j << endl;
            R[j] = i+1;
            L.pop_back();
            ps(L);
        }
        L.push_back(i);
        //cerr << "push " << i << endl;
        ps(L);
        if (L.size() > 1)
        {
            int j = L[L.size()-2];
            double x = intersect(P[j], P[j+1], P[i], P[i+1]);
            //cerr << "intersect(" << j << ", " << i << ") = " << x << endl;
            if (x > P[i].x)
                E.emplace(x, L.size()-2, j, i);
        }
    }
    for (auto r : R)
        cout << r << ' ';
    cout << "0" << endl;
}

int main()
{
    int z;
    for (cin >> z; z; --z)
        testcase();
    return 0;
}
