#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;

const int kMaxN = 300;

int n;
int leftBorders[kMaxN], rightBorders[kMaxN], distances[kMaxN];
int all[2 * kMaxN];
int maxOnSegment[2 * kMaxN];
int d[2 * kMaxN][2 * kMaxN];
const int inf = 1e9;

int rec(int l, int r) {
	if(l > r)
		return 0;
	
	int & result = d[l][r];
	if(result != -1)
		return result;
	result = inf;
	
	int currentMax = 0;
	for(int i = 0; i < n; i++) {
		if(l <= leftBorders[i] && rightBorders[i] <= r) {
			currentMax = max(currentMax, distances[i]);
		}
	}
	
	for(int i = l; i <= r; i++) {
		result = min(result, rec(l, i - 1) + currentMax + rec(i + 1, r));
	}
	
	return result;
}

void solveOne() {
	scanf("%d", &n);
	for(int i = 0; i < n; i++) {
		scanf("%d%d%d", &leftBorders[i], &rightBorders[i], &distances[i]);
		all[2 * i] = leftBorders[i];
		all[2 * i + 1] = rightBorders[i];
	}
	sort(all, all + 2 * n);
	int m = distance(all, unique(all, all + 2 * n));
	for(int i = 0; i < n; i++) {
		leftBorders[i] = distance(all, lower_bound(all, all + m, leftBorders[i]));
		rightBorders[i] = distance(all, lower_bound(all, all + m, rightBorders[i]));
		assert(leftBorders[i] <= rightBorders[i]);
		//printf("%d %d\n", leftBorders[i], rightBorders[i]);
		for(int j = leftBorders[i]; j <= rightBorders[i]; j++) {
			maxOnSegment[j] = max(maxOnSegment[j], distances[j]);
		}
	}
	memset(d, -1, sizeof(d));
	int result = rec(0, m - 1);
	printf("%d\n", result);
}

int main() {
	int tests;
	scanf("%d", &tests);
	for(int test = 0; test < tests; test++)
		solveOne();
	return 0;
}