#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>

#define int long long

using namespace std;

int const LIM = 1001;

int sqr(int x) {
    return x * x;
}

int gcd(int a, int b) {
    return a == 0 ? b : gcd(b % a, a);
}

struct cog_t {
    int x, y, r;
};

struct answer_t {
    int p, q;
    bool clockwise;
};

int n;
cog_t cogs[LIM];
answer_t answer[LIM];
bool used[LIM];

int32_t main() {
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) {
        cin >> n;
        for (int i = 0; i < n; ++i) {
            used[i] = false;
            cin >> cogs[i].x >> cogs[i].y >> cogs[i].r;
        }
        used[0] = true;
        answer[0].p = 1;
        answer[0].q = 1;
        answer[0].clockwise = true;
        queue<int> q;
        q.push(0);
        while (!q.empty()) {
            int u = q.front();
            q.pop();
            for (int i = 0; i < n; ++i) {
                if (!used[i] &&
                        sqr(cogs[i].x - cogs[u].x) + sqr(cogs[i].y - cogs[u].y) == sqr(cogs[u].r) + 2 * cogs[u].r * cogs[i].r + sqr(cogs[i].r)) {
                    used[i] = true;
                    int p1 = answer[u].p * cogs[u].r;
                    int q1 = answer[u].q * cogs[i].r;
                    int g = gcd(p1, q1);
                    answer[i].p = p1 / g;
                    answer[i].q = q1 / g;
                    answer[i].clockwise = !answer[u].clockwise;
                    q.push(i);
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                cout << "not moving" << '\n';
            } else {
                cout << answer[i].p;
                if (answer[i].q != 1) {
                    cout << '/' << answer[i].q;
                }
                cout << ' ';
                cout << (answer[i].clockwise ? "clockwise" : "counterclockwise") << '\n';
            }
        }
    }
    return 0;
}
