#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <stack>

using namespace std;

const int MAX_N = 1000005;
const int MOD = 1000000009;

int n, dp[MAX_N][2][2], cf[30][30][30][3][3];
string s[3];

int get(char c) {
    if (c == 'a' - 1) {
        return 0;
    }
    if (c == '?') {
        return 27;
    }

    return c - 'a' + 1;
}

int solve(int x, int y, int z, int a, int b) {
    int &q = cf[x][y][z][a][b];

    if (q >= 0) {
        return q;
    }

    q = 0;

    if (x == 27) {
        for (int i = 1; i <= 26; i++) {
            q = (q + solve(i, y, z, a, b)) % MOD;
        }
    } else if (y == 27) {
        for (int i = 1; i <= 26; i++) {
            q = (q + solve(x, i, z, a, b)) % MOD;
        }
    } else if (z == 27) {
        for (int i = 1; i <= 26; i++) {
            q = (q + solve(x, y, i, a, b)) % MOD;
        }
    } else {
        q = ((a == 0 && x != y) || (a == 1 && x >= y) || (b == 0 && y != z) || (b == 1 && y >= z)) ^ 1;
    }

    return q;
}

int main() {
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);

    memset(cf, -1, sizeof(cf));

    int tests;

    cin >> tests;

    for (int test = 0; test < tests; test++) {
        for (int i = 0; i < 3; i++) {
            cin >> s[i];
        }

        n = max(s[0].size(), max(s[1].size(), s[2].size()));

        for (int i = 0; i < 3; i++) {
            s[i] += string(n - s[i].size(), 'a' - 1);
        }

        memset(dp, 0, sizeof(dp));

        dp[0][0][0] = 1;

        for (int i = 1; i <= n; i++) {
            int x = get(s[0][i - 1]), y = get(s[1][i - 1]), z = get(s[2][i - 1]);

            for (int j = 0; j < 2; j++) {
                for (int k = 0; k < 2; k++) {
                    for (int l = 0; l <= j; l++) {
                        for (int m = 0; m <= k; m++) {
                            int a = j ^ l, b = k ^ m;

                            if (j == 1 && l == 1) {
                                a = 2;
                            }

                            if (k == 1 && m == 1) {
                                b = 2;
                            }

                            dp[i][j][k] = (dp[i][j][k] + (long long)dp[i - 1][l][m] * solve(x, y, z, a, b)) % MOD;
                        }
                    }
                }
            }
        }

        cout << dp[n][1][1] << endl;
    }

    return 0;
}
