#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

const int maxn = 1005;

bool mark[maxn];
pii points[maxn];
int r[maxn];
int mv[maxn];
int n;
i64 p[maxn];
i64 q[maxn];

inline int sqr(int x)
{
	return x * x;
}

i64 gcd(i64 x, i64 y)
{
	if (x == 0 || y == 0)
		return x + y;
	if (x > y)
		return gcd(x % y, y);
	else return gcd(y % x, x);
}

void dfs(int v)
{
	mark[v] = true;
	forn(j, n) if (!mark[j])
	{
		int sqrd = sqr(points[v].first - points[j].first) + sqr(points[v].second - points[j].second);
		if (sqrd == sqr(r[v] + r[j]))
		{
			p[j] = p[v] * r[v];
			q[j] = q[v] * r[j];
			i64 g = gcd(p[j], q[j]);
			p[j] /= g;
			q[j] /= g;
			mv[j] = -mv[v];
			dfs(j);
		}
	}
}



int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int tests;
	scanf("%d", &tests);
	forn(test, tests)
	{
		scanf("%d", &n);
		forn(j, n)
		{
			scanf("%d%d%d", &points[j].fi, &points[j].se, &r[j]);
			mark[j] = false;
		}
		mv[0] = 1;
		p[0] = q[0] = 1;
		dfs(0);
		forn(j, n)
		{
			if (!mark[j])
			{
				printf("not moving\n");
				continue;
			}
			if (q[j] == 1)
				printf("%lld ", p[j]);
			else printf("%lld/%lld ", p[j], q[j]);
			if (mv[j] == 1)
				printf("clockwise\n");
			else printf("counterclockwise\n");
		}
	}
}