#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

#define MAXN 600

int l[MAXN], r[MAXN];
int sorted_l[MAXN], sorted_r[MAXN], sorted_p[MAXN];
int cost[MAXN][MAXN];
int d[MAXN];

bool cmp1(int i1, int i2) {
	return l[i1] < l[i2];
}

bool cmp2(int i1, int i2) {
	return r[i1] < r[i2];
}

bool insideP(int L, int R, int p) {
	return L <= p && p <= R;
}

bool inside(int L, int R, int i) {
	return L <= l[i] && r[i] <= R;
}

int n;

li calc(int l_i, int r_i) {
	if (cost[l_i][r_i] != -1) return cost[l_i][r_i];
	int L = l[l_i];
	int R = r[r_i];
	if (L >= R) return 0;
	int maxdi = -1;
	for (int i = 0; i < n; i++) {
		if (inside(L, R, i)) {
			if (maxdi == -1 || d[i] > d[maxdi])
				maxdi = i;
		}
	}
	if (maxdi == -1) return cost[l_i][r_i] = 0;
	int last_r = -1, cur_r = 0;
	int first_l = 0;
	int res = 2e9;
	for (int i = 0; i < 2 * n; i++) {
		int p = sorted_p[i];
		while (first_l < n && (!inside(L, R, sorted_l[first_l]) || l[sorted_l[first_l]] <= p)) first_l++;
		while (cur_r < n && r[sorted_r[cur_r]] < p) {
			if (inside(L, R, sorted_r[cur_r])) {
				last_r = cur_r;
			}
			cur_r++;
		}
		if (insideP(l[maxdi], r[maxdi], p)) {
			int temp = d[maxdi];
			if (last_r != -1) temp += calc(l_i, sorted_r[last_r]);
			if (first_l != n) temp += calc(sorted_l[first_l], r_i);
			res = min(res, temp);
		}
	}
	return cost[l_i][r_i] = res;
}

int main()
{
	ios_base::sync_with_stdio(false);
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int t; cin >> t;
	for (int ii = 0; ii < t; ii++) {
		cin >> n;
		for (int i = 0; i < n; i++) {
			cin >> l[i] >> r[i] >> d[i];
			sorted_l[i] = sorted_r[i] = i;
			sorted_p[i * 2] = l[i];
			sorted_p[i * 2 + 1] = r[i];
		}
		sort(sorted_l, sorted_l + n, cmp1);
		sort(sorted_r, sorted_r + n, cmp2);
		sort(sorted_p, sorted_p + 2 * n);
		for (int i = 0; i < n; i++)
			for (int j = 0; j < n; j++)
				cost[i][j] = -1;
		cout << calc(sorted_l[0], sorted_r[n - 1]) << endl;
	}
}