#include <iostream>
#include <vector>

using namespace std;

long long GCD(long long a, long long b)
{
    if (a == 0)
        return b;
    if (b == 0)
        return a;
    return GCD(b, a % b);
}

void DFS(pair < pair <long long, long long>, long long> * A, vector <long long> * B, pair <long long, pair <long long, long long> > * C, long long ind)
{
    for (long long i = 0; i < B[ind].size(); ++i)
    {
        if(C[B[ind][i]].first == 0)
        {
            C[B[ind][i]].first = (C[ind].first == 1 ? 2 : 1);
            C[B[ind][i]].second.first = C[ind].second.first * A[ind].second;
            C[B[ind][i]].second.second = C[ind].second.second * A[B[ind][i]].second;
            int gcd = GCD(C[B[ind][i]].second.first, C[B[ind][i]].second.second);
            C[B[ind][i]].second.first /= gcd;
            C[B[ind][i]].second.second /= gcd;
            DFS(A, B, C, B[ind][i]);
        }
    }
}

int main()
{
    long long t;
    cin >> t;
    while (t--)
    {
        long long n;
        cin >> n;
        pair < pair <long long, long long>, long long> A[n];
        for (long long i = 0; i < n; ++i)
        {
            cin >> A[i].first.first >> A[i].first.second >> A[i].second;
        }
        vector <long long> B[n];
        pair <long long, pair <long long, long long> > C[n];
        for (long long i = 0; i < n; ++i)
        {
            for (long long j = i + 1; j < n; ++j)
            {
                if ((A[i].first.first - A[j].first.first) * (A[i].first.first - A[j].first.first) + (A[i].first.second - A[j].first.second) * (A[i].first.second - A[j].first.second) == (A[i].second + A[j].second) * (A[i].second + A[j].second))
                {
                    B[i].push_back(j);
                    B[j].push_back(i);
                }
           }
        }
        for (long long i = 1; i < n; ++i)
            C[i] = make_pair (0, make_pair(0, 0));
        C[0] = make_pair(1, make_pair(1, 1));
        DFS(A, B, C, 0);
        for (long long i = 0; i < n; ++i)
        {
            if (C[i].first == 0)
                cout << "not moving" << endl;
            else
            {
                if (C[i].second.second == 1)
                    cout << C[i].second.first << ' ';
                else
                    cout << C[i].second.first << '/' << C[i].second.second << ' ';
                if (C[i].first == 1)
                    cout << "clockwise" << endl;
                else
                    cout << "counterclockwise" << endl;
            }
        }
    }
}
