#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int M = (int) 1e5 + 10;
const int N = 1111;
const int step = 333;
pair< int, pair<int, int> > edges[M];
vector< pair<int, int> > adj[N];
int t, n, m, q, u, v, ans[M], sum[M / step + 1][M];

int dfs(int u, int v, int par) {
	for (int i = 0; i < sz(adj[u]); ++i) {
		int nxt = adj[u][i].fs, nxt_e = adj[u][i].sc;
		if (nxt == par) continue;
		if (nxt == v) return nxt_e;
		int res = dfs(nxt, v, u);
		if (res != -1) return (edges[res].fs > edges[nxt_e].fs) ? res : nxt_e; 
	}
	return -1;
}

int get(int l, int r, int bound) {
	int res = 0;
	while ((l <= r) && (l % step != 0)) {
		res += (ans[l] <= bound) ? edges[l].fs : 0;
		l++;
	}
	while ((l <= r) && ((r + 1) % step != 0)) {
		res += (ans[r] <= bound) ? edges[r].fs : 0;
		r--;
	}
	for (int i = l / step; i < (r + 1) / step; ++i)
		res += sum[i][bound];
	return res;
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%d", &t);
	for (int it = 0; it < t; ++it) {
		scanf("%d%d", &n, &m);
		for (int i = 0; i < m; ++i)
			scanf("%d%d%d", &edges[i].sc.fs, &edges[i].sc.sc, &edges[i].fs), --edges[i].sc.fs, --edges[i].sc.sc;
		sort(edges, edges + m);
		for (int i = 0; i < n; ++i)
			adj[i].clear();
		for (int i = m - 1; i >= 0; --i) {
			int u = edges[i].sc.fs, v = edges[i].sc.sc, w = edges[i].fs, mx_e = dfs(u, v, -1);
			ans[i] = 0;
			if (mx_e != -1) {
				ans[mx_e] = i + 1;
				for (int j = 0; j < n; ++j)
					for (int k = 0; k < sz(adj[j]); ++k)
						if (adj[j][k].sc == mx_e) {
							swap(adj[j][k], adj[j].back());
							adj[j].pop_back();
							break;
						}
			}
			adj[u].pb(mp(v, i)), adj[v].pb(mp(u, i));
		}
		for (int i = 0; i < m / step + 1; ++i)
			for (int j = 0; j < m; ++j)
				sum[i][j] = 0;
		for (int i = 0; i < m; i++)
			sum[i / step][ans[i]] += edges[i].fs;
		for (int i = 0; i < m / step + 1; ++i)
			for (int j = 0; j < m; ++j)
				sum[i][j + 1] += sum[i][j];
		scanf("%d", &q);
		for (int i = 0, last = 0; i < q; ++i) {
			scanf("%d%d", &u, &v);
			u = lower_bound(edges, edges + m, mp(u - last, mp(-1, -1))) - edges, v = lower_bound(edges, edges + m, mp(v - last, mp(n, n))) - 1 - edges;
			printf("%d\n", last = get(u, v, u));
		}
	}
	return 0;
}