#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int maxn = 1000 + 100;
const int maxp = 10000 + 100;

const int maxcnt = 1400;

bool notIsPrime[maxp];
int p[maxp];
int pSize = 0;

int pIndex[maxp];

int v1[maxn][maxcnt];
int v2[maxn][maxcnt];
int R[maxn][maxcnt];

int n;
int x[maxn];
int y[maxn];
int r[maxn];

vector < vector<int> > g;

bool clockwise[maxn];
bool vis[maxn];

ll gcd(ll a, ll b)
{
	while (a)
	{
		b %= a;
		swap(a, b);
	}
	return b;
}

ll V1[maxn];
ll V2[maxn];

void dfs(int v)
{
	vis[v] = true;

	int sz = g[v].size();
	for (int i = 0; i < sz; ++i)
	{
		int to = g[v][i];
		if (vis[to])
			continue;
		clockwise[to] = !clockwise[v];
		
		

		/*for (int i = 0; i < maxcnt; ++i)
		{
			v1[to][i] = v1[v][i] + R[v][i];
			v2[to][i] = v2[v][i] + R[to][i];
		}*/

		V1[to] = V1[v] * r[v];
		V2[to] = V2[v] * r[to];
		ll q = gcd(V1[to], V2[to]);
		V1[to] /= q;
		V2[to] /= q;

		dfs(to);
	}
}

vi getVi(ll x)
{
	vi res;

	while (x)
	{
		res.push_back(x % 10);
		x /= 10;
	}

	return res;
}

void norm(vi& x)
{
	while (x.size() > 1 && x.back() == 0)
		x.pop_back();
}

vi operator+ (const vi& a, const vi& b)
{
	int aSize = a.size();
	int bSize = b.size();
	int n = max(aSize, bSize);
	vi res(n + 2);
	int t = 0;
	for (int i = 0; i < n || t; ++i)
	{
		t += (i < aSize ? a[i] : 0) + (i < bSize ? b[i] : 0);
		res[i] = t % 10;
		t /= 10;
	}
	norm(res);
	return res;
}

vi operator* (const vi& a, const vi& b)
{
	int aSize = a.size();
	int bSize = b.size();
	vi res(aSize + bSize + 2);
	for (int i = 0; i < aSize; ++i)
	{
		for (int j = 0; j < bSize; ++j)
		{
			res[i + j] += a[i] * b[j];
		}
	}
	int t = 0;
	for (int i = 0; i < res.size() || t; ++i)
	{
		if (i >= res.size())
			res.push_back(0);
		res[i] += t;
		t = res[i] / 10;
		res[i] %= 10;
	}
	norm(res);
	return res;
}

vi fastPow(vi x, int n)
{
	vi res = getVi(1);
	while (n)
	{
		if (n % 2 == 0)
		{
			n /= 2;
			x = x * x;
		}
		else
		{
			--n;
			res = res * x;
		}
	}
	return res;
}

void print(const vi& a)
{
	int n = a.size();
	for (int i = n - 1; i >= 0; --i)
		printf("%d", a[i]);
}

void solve()
{
	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
	{
		scanf("%d%d%d", &x[i], &y[i], &r[i]);
		vis[i] = false;


		/*memset(R[i], 0, sizeof(R[i]));

		int rr = r[i];
		for (int j = 2; j * j <= rr; ++j)
		{
			if (rr % j == 0)
			{
				int cnt = 0;
				while (rr % j == 0)
				{
					rr /= j;
					++cnt;
				}
				R[i][pIndex[j]] = cnt;
			}
		}
		if (rr > 1)
			R[i][pIndex[rr]]++;*/

	}
	g.clear();
	g.resize(n);
	for (int i = 0; i < n; ++i)
	{
		for (int j = i + 1; j < n; ++j)
		{
			if (sqr(x[i] - x[j]) + sqr(y[i] - y[j]) == sqr(r[i]) + sqr(r[j]) + 2 * r[i] * r[j])
			{
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}

	clockwise[0] = true;

	V1[0] = 1;
	V2[0] = 1;
	dfs(0);

	for (int i = 0; i < n; ++i)
	{
		if (!vis[i])
		{
			puts("not moving");
			continue;
		}

		/*vi z1 = getVi(1);
		vi z2 = getVi(1);

		bool ok = false;

		for (int j = 0; j < maxcnt; ++j)
		{
			int tmp = min(v1[i][j], v2[i][j]);
			v1[i][j] -= tmp;
			v2[i][j] -= tmp;
		
			if (v1[i][j])
			{
				int pp = p[j];
				z1 = z1 * fastPow(getVi(pp), v1[i][j]);
			}
			if (v2[i][j])
			{
				int pp = p[j];
				z2 = z2 * fastPow(getVi(pp), v2[i][j]);
				ok = true;
			}
		}*/

		/*print(z1);
		if (ok)
		{
			printf("/");
			print(z2);
		}*/

		printf("%lld", V1[i]);
		if (V2[i] != 1)
			printf("/%lld", V2[i]);
		printf(" ");

		if (clockwise[i])
			puts("clockwise");
		else
			puts("counterclockwise");
	}

}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 
	
	/*vi a = getVi(12345678901ll);
	vi b = getVi(10123456789ll);
	vi c = a * b;
	print(c);
	return 0;*/

	for (int i = 2; i < maxp; ++i)
	{
		if (!notIsPrime[i])
		{
			pIndex[i] = pSize;
			p[pSize++] = i;
			for (int j = i + i; j < maxp; j += i)
			{
				notIsPrime[j] = true;
			}
		}
	}

	/*for (int i = 0; i < pSize; ++i)
		printf("%d ", p[i]);
	puts("");
	*/

	int T;
	scanf("%d", &T);
	for (int t = 0; t < T; ++t)
	{
		solve();
	}
	

	return 0;
}