#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = 1010;
const int M = 10;

int n;
int h[N], num[N], sum[N], prev[N];
int p[M][N];
int f[M][M];
vi g[N];
vector<pair<pii, pii> > lst[N];
int d[N][(1 << M)];

void dfs(int v, int pv, int ch = 0) {
	p[0][v] = pv;
	h[v] = ch;
	if (pv != -1) {
		g[v].erase(find(all(g[v]), pv));
	}
	for (int i = 0; i < sz(g[v]); ++i) {
		dfs(g[v][i], v, ch + 1);
	}
}

inline int get_lca(int a, int b, int &c, int &d) {
	if (h[a] < h[b]) {
		swap(a, b);
		swap(c, d);
	}
	for (int i = M - 1; i >= 0; --i) {
		if (p[i][a] != -1 && h[p[i][a]] > h[b]) {
			a = p[i][a];
		}
	}
	if (p[0][a] == b) {
		c = a;
		d = a;
		return p[0][a];
	}
	for (int i = M - 1; i >= 0; --i) {
		if (p[i][a] != p[i][b]) {
			a = p[i][a];
			b = p[i][b];
		}
	}
	c = a;
	d = b;
	return p[0][a];
}

void solve(int v) {
	for (int i = 0; i < sz(g[v]); ++i) {
		solve(g[v][i]);
		num[g[v][i]] = i;
	}
	for (int i = 0; i < sz(g[v]); ++i) {
		for (int j = 0; j < sz(g[v]); ++j) {
			f[i][j] = 0;
		}
	}
	for (int i = 0; i < sz(lst[v]); ++i) {
		int a = num[lst[v][i].sc.fs], b = num[lst[v][i].sc.sc];
		if (a > b) {
			swap(a, b);
		}
		f[a][b] = max(f[a][b], sum[lst[v][i].fs.fs] + sum[lst[v][i].fs.sc] + 1);
	}
	for (int i = 0; i < (1 << sz(g[v])); ++i) {
		d[v][i] = 0;
		for (int j = 0; j < sz(g[v]); ++j) {
			if ((i & (1 << j)) == 0) {
				continue;
			}
			d[v][i] = max(d[v][i], d[v][(i ^ (1 << j))]);
			for (int z = j; z < sz(g[v]); ++z) {
				if ((i & (1 << z)) != 0) {
					int pi = (i ^ (1 << j));
					if (j < z) {
						pi ^= (1 << z);
					}
					d[v][i] = max(d[v][i], d[v][pi] + f[j][z]); 
				}
			}
		}
	}
	prev[v] = v;
	int all = (1 << sz(g[v])) - 1;
	sum[v] = d[v][all];
	for (int i = 0; i < n; ++i) {
		if (prev[i] != -1 && p[0][prev[i]] == v) {
			sum[i] += d[v][(all ^ (1 << num[prev[i]]))];
			prev[i] = v;
		}
	}
}

inline void solve() {
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		g[i].clear();
		prev[i] = -1;
		lst[i].clear();
		sum[i] = 0;
	}
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		scanf("%d %d", &a, &b);
		--a;
		--b;
		g[a].pb(b);
		g[b].pb(a);
	}
	dfs(0, -1);
	for (int i = 1; i < M; ++i) {
		for (int j = 0; j < n; ++j) {
			if (p[i - 1][j] != -1) {
				p[i][j] = p[i - 1][p[i - 1][j]];
			} else {
				p[i][j] = -1;
			}
		}
	}
	int m;
	scanf("%d", &m);
	for (int i = 0; i < m; ++i) {
		int a, b;
		scanf("%d %d", &a, &b);
		--a;
		--b;
		int pa, pb;
		int c = get_lca(a, b, pa, pb);
		lst[c].pb(mp(mp(a, b), mp(pa, pb)));
	}
	solve(0);
	printf("%d\n", d[0][(1 << sz(g[0])) - 1]);
}

int main() {
#ifdef LOCAL42
#define TASK "A"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
