#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

const int N = 1050;

int X[N], Y[N], R[N];

bool A[N][N];

int sqr(int x)
{
	return x * x;
}


inline bool touch(int x, int y)
{
	return (sqr(X[x] - X[y]) + sqr(Y[x] - Y[y]) == sqr(R[x] + R[y]));
}

int dir[N];
int n;
	
void DFS(int x, int d = 1)
{
	dir[x] = d;
	for (int i = 0; i < n; i++)
		if (A[x][i])
		{
			if (dir[i] != 0)
				assert(dir[i] == -dir[x]);
			else
				DFS(i, -d);
		}
}

int gcd(int a, int b)
{
	while (b)
		a %= b, swap(a, b);
	return a;
}

void solve()
{
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		scanf("%d %d %d", &X[i], &Y[i], &R[i]);
	
	for (int i = 0; i < n; i++)
		for (int j = 0; j < i; j++)
			A[i][j] = A[j][i] = touch(i, j);

	memset(dir, 0, sizeof(int) * n);
	DFS(0);
	for (int i = 0; i < n; i++)
	{
		if (dir[i] == 0)
			puts("not moving");
		else
		{
			int a = R[0], b = R[i];
			int g = gcd(a, b);
			a /= g, b /= g;
			if (b == 1)
				printf("%d ", a);
			else
				printf("%d/%d ", a, b);
			if (dir[i] == 1)
				printf("clockwise\n");
			else
				printf("counterclockwise\n");
		}
	}
}

int main() {
#ifdef LOCAL42
#define TASK "D"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int T;
	scanf("%d", &T);
	for (int i = 0; i < T; i++)
		solve();
	return 0;
}
