#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = int(1e6) + 100;
const int MOD = int(1e9) + 9;

int len[3];
char s[3][N];
int d[N][2][2];
int f[28][28][2][2][2][2];

inline void norm(int &a) {
	if (a >= MOD) {
		a -= MOD;
	}
}

inline int calc(char ch1, int j, int nj, char ch) {
	if (ch1 == '?') {
		if (nj == 0) {
			return 1;
		} else {
			if (j == 0) {
				return max(ch - 'a', 0);
			} else {
				return 26;
			}
		}
	} else {
		if (nj == 0) {
			return (ch1 == ch);
		} else {
			if (j == 0) {
				return (ch1 < ch);
			} else {
				return 1;
			}
		}
	}
}

inline int calc2(char ch1, int j, int nj, char ch) {
	if (ch1 == '?') {
		if (nj == 0) {
			return 1;
		} else {
			if (j == 0) {
				return min(26, 'z' - ch);
			} else {
				return 26;
			}
		}
	} else {
		if (nj == 0) {
			return (ch1 == ch);
		} else {
			if (j == 0) {
				return (ch < ch1);
			} else {
				return 1;
			}
		}
	}
}

inline void go(int i, int j, int z, char ch) {
	for (int nj = j; nj <= 1; ++nj) {
		for (int nz = z; nz <= 1; ++nz) {
			int res = (1LL * d[i][j][z] * calc(s[0][i], j, nj, ch) * calc2(s[2][i], z, nz, ch)) % MOD;
			d[i + 1][nj][nz] += res;
			norm(d[i + 1][nj][nz]);
		}
	}
}

inline int code(char ch) {
	if (ch == '?') {
		return 27;
	}
	return ch - 'a' + 1;
}

inline char decode(int c) {
	if (c == 27) {
		return '?';
	}
	return 'a' + c - 1;
}

inline void init() {
	for (int c1 = 0; c1 < 28; ++c1) {
		for (int c2 = 0; c2 < 28; ++c2) {
			for (int j = 0; j < 2; ++j) {
				for (int nj = j; nj < 2; ++nj) {
					for (int z = 0; z < 2; ++z) {
						for (int nz = z; nz < 2; ++nz) {
							for (int h = 0; h < 26; ++h) {
								int res = calc(decode(c1), j, nj, 'a' + h) * calc2(decode(c2), z, nz, 'a' + h);
								f[c1][c2][j][nj][z][nz] += res;
								norm(f[c1][c2][j][nj][z][nz]);
							}
						}
					}
				}
			}
		}
	}
}

inline void solve() {
	int n = 0;
	for (int i = 0; i < 3; ++i) {
		gets(s[i]);
		len[i] = strlen(s[i]);
		n = max(n, len[i]);
	}
	for (int i = 0; i < 3; ++i) {
		for (int j = len[i]; j < n; ++j) {
			s[i][j] = 'a' - 1;
		}
	}
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j < 2; ++j) {
			for (int z = 0; z < 2; ++z) {
				d[i][j][z] = 0;
			}
		}
	}
	d[0][0][0] = 1;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < 2; ++j) {
			for (int z = 0; z < 2; ++z) {
				if (d[i][j][z] == 0) {
					continue;
				}
				if (s[1][i] == '?') {
					/*for (int h = 0; h < 26; ++h) {
						go(i, j, z, 'a' + h);
					}*/
					for (int nj = j; nj <= 1; ++nj) {
						for (int nz = z; nz <= 1; ++nz) {
							int res = (1LL * d[i][j][z] * f[code(s[0][i])][code(s[2][i])][j][nj][z][nz]) % MOD;
							d[i + 1][nj][nz] += res;
							norm(d[i + 1][nj][nz]);
						}
					}
				} else {
					go(i, j, z, s[1][i]);
				}
			}
		}
	}
	int ans = d[n][1][1];
	printf("%d\n", ans);
}

inline void gen() {
	freopen("F2.in", "w", stdout);
	cout << 1 << endl;
	for (int j = 0; j < 3; ++j) {
		for (int i = 0; i < int(1e6); ++i) {
			cout << "?";
		}
		cout << endl;
	}
	exit(0);
}

int main() {
	init();
	//gen();
#ifdef LOCAL42
#define TASK "F"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int t;
	scanf("%d", &t);
	gets(s[0]);
	for (int i = 0; i < t; ++i) {
		solve();
	}
	cerr << 1.0 * clock() / CLOCKS_PER_SEC << endl;
	return 0;
}
