#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
#include <bitset>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 2000*100 + 10;
const dbl eps = 1e-7;
const int mod = 1e9 + 7;

int x[maxn], y[maxn], r[maxn];

vector <int> g[maxn];
pair <int, int> rate[maxn];
bool clockwise[maxn];
bool used[maxn];

bool touch (int i, int j) {
	return ((x[i] - x[j])*(x[i] - x[j]) + (y[i] - y[j])*(y[i] - y[j])) == (r[i] + r[j])*(r[i] + r[j]);
}

int gcd (int a, int b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

void dfs(int v, int p = -1) {
	used[v] = true;
	if (p != -1) {
		clockwise[v] = !clockwise[p];
		int a = rate[p].X*r[p];
		int b = rate[p].Y*r[v];
		int d = gcd(a, b);
		a /= d; b /= d;
		rate[v] = mp(a, b);
	}
	for (int i = 0; i < sz(g[v]); i++)
		if (!used[g[v][i]])
			dfs(g[v][i], v);
}

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	int t;
	scanf("%d", &t);
	while (t--) {		
		int n;
		scanf("%d", &n);
		int w = 0, b = 0;

		vector <pair <int, char> > input (n);
		for (int i = 0; i < n; i++) {
			int cnt;
			char c;
			scanf("%d %c\n", &cnt, &c);
			input[i] = mp(cnt, c);
			if (c == 'W')
				w += cnt;
			else
				b += cnt;
		}
		pair <int, int> rall = mp (w, b);
		if ((w == 0) || (b == 0)) {
			printf("%d\n", w + b);
			continue;
		}
		w = b = 0;
		int ans = 0;
		for (int i = 0; i < n; i++) {
			pair <int, char> cur = input[i];
			if (cur.Y == 'W') {
				 if ((rall.Y*w < rall.X*b) && (rall.X*b <= (w + cur.X)*rall.Y)) {
					 ans++;
					 w = cur.X - rall.X*b/rall.Y;
					 b = 0;
				 }
				 else
					w += cur.X;
			}
			else {
				if ((rall.X*b < rall.Y*w) && (rall.Y*w <= (b + cur.X)*rall.X)) {
					ans++;
					b = cur.X - rall.Y*w/rall.X;
					w = 0;
				}
				else
					b += cur.X;
			}
		}
		printf("%d\n", ans);
	}
	return 0;
}