#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

int n, k;
const int N = 150095;
pt a[N];

void gen()
{
	n = 10;
	forn (i, 10)
		a[i].ft = rand(), a[i].sc = rand();
	k = rand() % 10;
}

bool read() {
	if (scanf("%d%d", &n, &k) != 2)
		return false;

	forn (i, n)
		scanf("%d%d", &a[i].sc, &a[i].ft);

	//gen();
	return true;
}

int dp[N][10];
int dp2[1 << 15][10];

int calcdp(int mask, int b)
{
	if (dp2[mask][b] != -1)
		return dp2[mask][b];

	dp2[mask][b] = 0;
	
	forn (i, n)
	{
		if (mask & (1 << i))
			continue;
		if (b == k)
			dp2[mask][b] = max(dp2[mask][b], a[i].sc - a[i].ft);
		else
			dp2[mask][b] = max(dp2[mask][b], min(a[i].sc - a[i].ft, calcdp(mask ^ (1 << i), b + 1) - a[i].ft));
	}

	return dp2[mask][b];
}

int naive()
{
	forn (i, 1 << 10)
		forn (j, 10)
				dp2[i][j] = -1; 
	return calcdp(0, 0);	
}

bool cmp(const pt &a, const pt &b)
{
	return a.sc < b.sc;
}

void solve() {

	sort(a, a + n, cmp);

	forn (i, n)
		forn (j, k + 1)
			dp[i][j] = -INF;

	forn (i, k + 1)
		dp[n][i] = 0;

	for (int i = n - 1; i >= 0; --i)
	{
		forn (j, k)
			dp[i][j] = max(dp[i + 1][j], min(a[i].sc - a[i].ft, dp[i + 1][j + 1] - a[i].ft));
		dp[i][k] = max(dp[i + 1][k], a[i].sc - a[i].ft);
	}
	/*if (naive() != dp[0][0])
	{
		cout << "_____________" << endl;
		cout << n << ' ' << k << endl;
		forn (i, n)
			cout << a[i].sc << ' ' << a[i].ft << endl;
		cout << "_____________" << endl;
		cout << dp[0][0] << ' ' << naive() << endl;
		assert(false);
	}*/
	cout << dp[0][0] << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	int t;
	scanf("%d", &t);

	while (read())
		solve();

	return 0;
}