#include <iostream>
#include <sstream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long int Z;

Z gcd(Z a, Z b) {
	if(b == 0) return a;
	return gcd(b, a % b);
}

struct R {
	R() { }
	R(Z p, Z q) {
		if(q < 0) {
			 p = -p;
			 q = -q;
		}
		if(p == 0) q = 1;
		Z d = gcd(abs(p), abs(q));
		p /= d;
		q /= d;
		a = p;
		b = q;
	}

	Z a;
	Z b;
};

R operator*(R x, R y) {
	return R(x.a * y.a, x.b * y.b);
}

Z x[1005];
Z y[1005];
Z r[1005];
vector<vector<pair<Z, R>>> G;

R roto[1005];
bool found[1005];
void dfs(Z v) {
	if(found[v]) return;
	found[v] = true;
	
	for(auto p : G[v]) {
		roto[p.first] = p.second * roto[v];
		dfs(p.first);
	}
}

int main() {
	cin.sync_with_stdio(false);
	
	Z Te;
	cin >> Te;
	for(Z te = 0; te < Te; ++te) {
		Z n;
		cin >> n;
		G.clear();
		G.resize(n);
		
		for(Z i = 0; i < n; ++i) {
			cin >> x[i] >> y[i] >> r[i];
		}
		
		for(Z a = 0; a < n; ++a) {
		for(Z b = a + 1; b < n; ++b) {
			Z dx = x[b] - x[a];
			Z dy = y[b] - y[a];
			Z cr = r[a] + r[b];
			if(dx * dx + dy * dy == cr * cr) {
				G[a].emplace_back(b, R(-r[a], r[b]));
				G[b].emplace_back(a, R(-r[b], r[a]));
			}
		}
		}
		
		fill(roto, roto + n, R(0, 1));
		fill(found, found + n, false);
		
		roto[0] = R(1, 1);
		dfs(0);
		
		for(Z i = 0; i < n; ++i) {
			if(roto[i].a == 0) {
				cout << "not moving\n";
			} else if(roto[i].a > 0) {
				if(roto[i].b == 1) {
					cout << roto[i].a << " clockwise\n";
				} else {
					cout << roto[i].a << "/" << roto[i].b << " clockwise\n";
				}
			} else {
				if(roto[i].b == 1) {
					cout << -roto[i].a << " counterclockwise\n";
				} else {
					cout << -roto[i].a << "/" << roto[i].b << " counterclockwise\n";
				}
			}
		}
	}
	
	return 0;
}
