#include <iostream>
#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>
#include <memory.h>

using namespace std;

const int maxn = 1024;
const int maxm = 14;

int n;
int a[maxn], sum[maxn];
int p[maxn][1 << maxm];
char cp[maxn][1 << maxm];

int lg[1 << maxm], mx[1 << maxm];

void norm(int &mask1, int &mask2) {
	int m1 = mx[mask1];
	int m2 = mx[mask2];
	if (m1 > m2) {
		mask1 -= 1 << m1;
		mask2 += 1 << m1;
	}
	if (m1 == m2) {
		mask1 -= 1 << m1;
		mask2 -= 1 << m2;
		mask2 += 1 << (m2 + 1);
	}
}

void rec(int n, int mask) {
	if (n == 0) return;
	rec(n - 1, p[n][mask]);
	cout << cp[n][mask];
}

int main() {
	for (int i = 0; i < maxm; i++) for (int j = 1 << i; j < 1 << maxm; j++) mx[j] = i;

	freopen("input.txt", "r", stdin);

	int T;
	scanf("%d", &T);
	while (T--) {
		scanf("%d", &n);
		for (int i = 0; i < n; i++) {
			scanf("%d", &a[i]);
			sum[i + 1] = sum[i] + a[i];
		}
		memset(p, -1, sizeof(p));
		p[0][0] = 0;
		for (int i = 0; i < n; i++) {
			for (int mask1 = 0; mask1 < 1 << maxm; mask1++) {
				if (p[i][mask1] == -1) continue;
				int mask2 = sum[i] - mask1;
				
				if (mask1 % a[i] == 0) {
					int nmask1 = mask1 + a[i];
					int nmask2 = mask2;
					norm(nmask1, nmask2);
					p[i + 1][nmask1] = mask1;
					cp[i + 1][nmask1] = 'l';
				}
				if (mask2 % a[i] == 0) {
					int nmask1 = mask1;
					int nmask2 = mask2 + a[i];
					norm(nmask1, nmask2);
					p[i + 1][nmask1] = mask1;
					cp[i + 1][nmask1] = 'r';					
				}
			}
		}
		bool found = 0;
		for (int mask1 = 0; mask1 < 1; mask1++) {
			int mask2 = sum[n] - mask1;
			if ((mask2 & (mask2 - 1))) continue;
			if (p[n][mask1] != -1) {
				found = 1;
				rec(n, mask1);
				break;
			}
		}
		if (!found) cout << "no";
		cout << endl;
	}

	return 0;
}