#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

using namespace std;

#define fmin fminfmin

const int N = 300500;
const int INF = 1e9;
const int K = 12;

long long f[K][N], fmin[K][N];
int n, k, tt;
pair<int, int> a[N];

bool cmp(pair<int, int> u, pair<int, int> v) {
	return min(u.first - u.second, v.first - u.second - v.second) < 
               min(v.first - v.second, u.first - u.second - v.second);
}

bool ok(int h) {
	for (int i = 0; i < n; i++) {
		if (a[i].first - a[i].second >= h) {
			f[0][i] = a[i].second;
		} else f[0][i] = INF;
	}
	for (int i = 1; i <= k; i++) {
		fmin[i][0] = f[i][0];
		for (int j = 1; j < n; j++) {
			fmin[i][j] = min(fmin[i][j - 1], f[i - 1][j]);
		}
		for (int j = 0; j < n; j++) {
			if (j < i) {
				f[i][j] = INF;
				continue;
			} 
			f[i][j] = a[j].second + fmin[i - 1][j - 1];
			if (a[j].first - f[i][j] < h) {
				f[i][j] = INF;
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (f[k][i] != INF) return true;
	}
	return false;
}

int main() {
	freopen("input.txt", "r", stdin);
	scanf("%d", &tt);
	while (tt--) {
		scanf("%d%d", &n, &k);
		for (int i = 0; i < n; i++) scanf("%d%d", &a[i].first, &a[i].second);
		if (k >= n) {
			puts("0");
			continue;
		}
		sort(a, a + n, cmp);
		int ll = 0, rr = 1e6 + 1;
		while (ll < rr - 1) {
			int mid = (ll + rr) / 2;
			if (ok(mid)) ll = mid; else
			rr = mid;
		}
		printf("%d\n", ll);
	}
}	