#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <queue>

#define MAX_N 1000

//typedef long long ll;
//typedef long double ld;

using namespace std;

int n;
int x[MAX_N];
int y[MAX_N];
int r[MAX_N];

//speed top/bottom
int st[MAX_N], sb[MAX_N];
bool clockwise[MAX_N];
//sb == 0 - not found

int eNr[MAX_N];
int e[MAX_N][MAX_N];

inline int sqr(int a) {
	return a*a;
}


int gcd(int a, int b) {
	while (b != 0) {
		int temp = a % b;
		a = b;
		b = temp;
	}
	return a;
}

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	
	cin.sync_with_stdio(false);

	int tests;
	scanf("%d", &tests);
	for (int test = 0; test < tests; test++) {
		scanf("%d", &n);
		for (int i = 0; i < n; ++i) {
			scanf("%d %d %d", &x[i], &y[i], &r[i]);
			eNr[i] = 0;
			st[i] = sb[i] = 0;
		}
		for (int i = 0; i < n; ++i)
			for (int j = i+1; j < n; ++j) {
				if (sqr(x[i] - x[j]) + sqr(y[i] - y[j]) == sqr(r[i] + r[j])) {
					e[i][eNr[i]++] = j;
					e[j][eNr[j]++] = i;
				}
			}

		st[0] = sb[0] = 1;
		clockwise[0] = true;

		queue<int> q;
		q.push(0);
		while (!q.empty()) {
			int now = q.front();
			q.pop();

			for (int i = 0; i < eNr[now]; ++i) {
				//cout << "now=" << now << endl;
				int next = e[now][i];
				if (sb[next] == 0) {
					//find speed
					//int a = r[0];
					//int b = r[next];
					//ll a = st[now] * (ll)r[now];
					//ll b = sb[now] * (ll)r[next];
					//gcd
					//b, a % b
					int g = gcd(r[0], r[next]);
					//a = r[0] / g;
					//b = r[next] / g;
					//cout << a << " " << b << endl;

					st[next] = r[0] / g;
					sb[next] = r[next] / g;
					clockwise[next] = !clockwise[now];

					q.push(next);
				}
			}
		}
		for (int i = 0; i < n; ++i) {
			if (sb[i] == 0)
				cout << "not moving" << endl;
			else {
				if (sb[i] == 1)
					cout << st[i];
				else
					cout << st[i] << '/' << sb[i];
				cout << ' ' << (clockwise[i] ? "clockwise" : "counterclockwise") << endl;
			}
		}
	}

	return 0;
}