#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <queue>

typedef long long ll;
typedef long double ld;

#define MAX_N 100000
#define DEBUG false

using namespace std;

int n;
int l[MAX_N];

int gc[2];//global count ratio (gcd'ed)


inline bool gettype(int pos) {
	return pos % 2 == 1;
}

int answer(int seg, int pos) {
	if (n == 1)
		return l[0];

	int segCount = 0;
	while (seg != n) {
		bool type = gettype(seg);//starting type

		int c[2] = {0, 0};
		c[type] = l[seg] - pos;

		for (int i = seg+1; i < n; i++) {
			bool newType = gettype(i);
		
			ll top = gc[newType] * c[!newType];
			ll bottom = gc[!newType];
		
			if (top % bottom == 0) {
				int reqB = (int)(top / bottom);
				int needsB = reqB - c[newType];
				if (needsB <= l[i]) {
					segCount++;
					if (needsB < l[i]) {
						seg = i;
						pos = needsB;
					}
					else {
						seg = i+1;
						pos = 0;
					}
					break;
				}
			}
			c[newType] += l[i];
		}
	}
	return segCount;
}

/*
int answer(int seg, int pos) {
	if (seg == n)
		return 0;
	printf("answer %d %d\n", seg, pos);
	bool type = gettype(seg);//starting type
	if (n == 1)
		return l[0];
	int c[2] = {0, 0};
	//negalima praleisti intervalu!
	c[type] = l[seg] - pos;
	for (int i = seg+1; i < n; i++) {
		bool newType = gettype(i);
		
		int top = gc[newType] * c[!newType];
		int bottom = gc[!newType];
		
		if (top % bottom == 0) {
			printf("have %d %d\n", c[0], c[1]);
			int reqB = top / bottom;
			printf("needs %d\n", reqB);
			int needsB = reqB - c[newType];
			if (needsB <= l[i]) {
				if (needsB < l[i])
					return answer(i, needsB) + 1;
				else
					return answer(i+1, 0) + 1;
				//printf("Found one: %d %d\n", cc[0], cc[1]);
			}
		}
		c[newType] += l[i];
	}

	//TODO: return sum? (NOT gc - it's gcd'ed)
	return 0;
}
*/

int gcd(int a, int b) {
	while (b != 0) {
		int temp = a % b;
		a = b;
		b = temp;
	}
	return a;
}

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int tests;
	scanf("%d", &tests);
	for (int test = 0; test < tests; ++test) {
		n = 0;
		int n0;
		scanf("%d", &n0);
		char prev;
		for (int i = 0; i < n0; ++i) {
			int count;
			scanf("%d", &count);
			char c = ' ';
			while (c != 'B' && c != 'W')
				c = getchar();
			//cout << '+' << c << ' ' << count << endl;
			//printf("%c %d\n", c, count);
			if (i == 0 || c != prev) {
				//new
				l[n++] = count;
				//cout << "new " << count << endl;
			}
			else {
				//append
				l[n-1] += count;
				//cout << "append " << count << endl;
			}
			prev = c;
		}
		
		gc[0] = gc[1] = 0;
		for (int i = 0; i < n; i += 2)
			gc[0] += l[i];
		for (int i = 1; i < n; i += 2)
			gc[1] += l[i];
		int ggcd = gcd(gc[0], gc[1]);
		gc[0] /= ggcd;
		gc[1] /= ggcd;
		if (DEBUG)
			printf("ratio: %d %d\n", gc[0], gc[1]);

		if (DEBUG) {
			for (int i = 0; i < n; ++i)
				printf("%d ", l[i]);
			printf("\n");
		}
		printf("%d\n", answer(0, 0));
		if (DEBUG)
			printf("--------------\n");
	}


	return 0;
}