#if 1
#include<cstdio>
#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>
#include<string>
#include<cstring>
#include<queue>
#include<stack>

#define X first
#define Y second
#define mp make_pair
#define pb push_back

using namespace std;

typedef long long li;
typedef long double ld;
typedef pair<int,int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;

struct wheel
{
	int x, y, r;
	int move, dir;
	li p, q;
	wheel() : move(0) {}
};

li gcd(li a, li b)
{
	while(a && b && (a %= b) && (b %= a));
	return a | b;
}

void dfs(int v, vi &used, vvi &g, vector<wheel> &w, int p = -1)
{
	if(used[v]) return;
	used[v] = 1;
	for (int i = 0; i < g[v].size(); ++i)
	{
		int to = g[v][i];
		if(to == p) continue;
		w[to].dir = w[v].dir ^ 1;
		w[to].move = 1;
		li p = w[v].p * w[v].r;
		li q = w[v].q * w[to].r;
		li d = gcd(p, q);
		w[to].p = p/d;
		w[to].q = q/d;
		dfs(to, used, g, w, v);
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int T; scanf("%d", &T);
	for (int t = 1; t <= T; ++t)
	{
		int n; scanf("%d", &n);
		vector<wheel> wheels(n);
		for (int i = 0; i < n; ++i) scanf("%d%d%d", &wheels[i].x, &wheels[i].y, &wheels[i].r);
		vvi g(n);
		for (int i = 0; i < n; ++i)
			for (int j = i + 1; j < n; ++j)
			{
				li a = wheels[i].x - wheels[j].x;
				li b = wheels[i].y - wheels[j].y;
				li c = wheels[i].r + wheels[j].r;
				if(a*a + b*b == c*c)
				{
					g[i].push_back(j);
					g[j].push_back(i);
				}
			}
		vi used(n);
		wheels[0].dir = 1;
		wheels[0].move = 1;
		wheels[0].p = wheels[0].q = 1;
		dfs(0, used, g, wheels);
		for (int i = 0; i < n; ++i)
		{
			if(!wheels[i].move) printf("not moving\n");
			else 
			{
				printf("%lld", wheels[i].p);
				if(wheels[i].q != 1) printf("/%lld", wheels[i].q);
				printf(" %s\n", wheels[i].dir ? "clockwise" : "counterclockwise");
			}
		}
	}
	return 0;
}
#endif